#include<stdio.h>
#include<stdlib.h>
#include<math.h>
//the two functions are below.
double E(double ref[1000], int size1);
double normcorr(double ref[1000], double array [1000], int size1, double Eref, double Earray);
//main function.
int main (void){
    double norm[1000], abnorm[1000], ref[1000], Eref, Enorm, Eabnorm;
    double corr_abn, corr_nor, diss_sim_abn, sim_nor;
    int i, size1;
    FILE *n, *a, *r;
    
    //openning the 3 files to read them.
    n = fopen("NormalECG.txt","r");
    a = fopen("AbnormalECG.txt","r");
    r = fopen("ReferenceECG.txt","r");
    
    if (n == NULL){
        printf ("Error, File Is Not Found");
        return (-1);
    }
    if (a == NULL){
        printf ("Error, File Is Not Found");
        return (-1);
    }
    if (r == NULL){
        printf ("Error, File Is Not Found");
        return (-1);
    }
  
	while(fscanf(r,"%lf",&ref[size1]) != EOF && fscanf(n,"%lf",&norm[size1]) != EOF && fscanf(a,"%lf",&abnorm[size1]) != EOF)
	size1++ ;
    //calling the first function.
    Eref = E(ref, size1);
    Enorm = E(norm, size1);
    Eabnorm = E(abnorm, size1);
    //calling the second function.
    corr_nor = normcorr(ref, norm, size1, Eref, Enorm);
    sim_nor = corr_nor * 100;
    
    corr_abn = normcorr(ref, abnorm, size1, Eref, Eabnorm);
    diss_sim_abn = corr_abn * -100;
    //closing the three files.
    fclose (n);
    fclose (a);
    fclose (r);
    //printing the output.
    printf ("The correlation between the Reference ECG and the Normal ECG is %.6lf ", corr_nor);
    printf ("Therefore, the similarity between the Reference ECG and the Normal ECG is %.1lf %% ", sim_nor);
    printf ("\n========================\n");
    printf ("The correlation between the Reference ECG and the Abnormal ECG is %.6lf ", corr_abn);
    printf ("Therefore, the dissimilarity between the Reference ECG and the Normal ECG is %.1lf %% ", diss_sim_abn);
    
    return (0);
}
// first equation.
double E(double array[1000], int size1){
    int j, sum = 0;
    for (j = 0; j<size1; j++){
    sum = sum + pow(array[j],2);}
    
    return (sum);
}
// second equation.
double normcorr(double ref[1000], double array [1000], int size1, double Eref, double Earray){
    int j, sum = 0;
    double norm = 0;
    for (j = 0; j<size1; j++){
    sum = sum + array[j]*ref[j] ;
	}
    norm = (1/sqrt (Eref * Earray)) * sum;
    
    return (norm);
}